import java.util.Scanner;

/**
 * Program rešava problem maksimalnog podniza celih brojeva. Tačnije nalazi
 * podniz susednih elemenata u nizu koji imaju maksimalnu sumu. Problem je rešen
 * na 4 načina različite efikasnosti i dodati su brojači operacija sabiranja da
 * bi se dodatno ilustrovale razlike.
 */
public class MaxNizaPoredjenje {

	static void maxNiza1(int[] niz) {
		int brojOp = 0;
		int max = 0;
		int pocetak = 1, kraj = 1;
		
		int n = niz.length;

		for (int d = 0; d < n; d++) {
			for (int g = d; g < n; g++) {
				int suma = 0;
				for (int i = d; i <= g; i++) {
					suma = suma + niz[i];
					brojOp++;
				}
				if (suma > max) {
					max = suma;
					pocetak = d;
					kraj = g;
				}
			}
		}

		System.out.println("Maksimum je " + max + " u intervalu od " + pocetak
				+ " do " + kraj);
		System.out.println("Broj racunskih operacija: " + brojOp);
	}

	static void maxNiza2(int[] niz) {
		int brojOp = 0;
		int pocetak = 1, kraj = 1;
		int max = 0;

		int n = niz.length;

		int[] pom = new int[n + 1];

		pom[0] = 0;
		for (int i = 1; i < n + 1; i++) {
			pom[i] = pom[i - 1] + niz[i - 1];
			brojOp++;
		}

		for (int d = 0; d < n; d++) {
			for (int g = d; g < n; g++) {
				int suma = pom[g + 1] - pom[d];
				brojOp++;
				if (suma > max) {
					max = suma;
					pocetak = d;
					kraj = g;
				}
			}
		}

		System.out.println("Maksimum je " + max + " u intervalu od " + pocetak
				+ " do " + kraj);
		System.out.println("Broj racunskih operacija: " + brojOp);
	}

	static void maxNiza3(int[] niz) {
		int brojOp = 0;
		int max = 0;
		int pocetak = 1, kraj = 1;

		int n = niz.length;

		for (int d = 0; d < n; d++) {
			int suma = 0;
			for (int g = d; g < n; g++) {
				suma = suma + niz[g];
				brojOp++;
				if (suma > max) {
					max = suma;
					pocetak = d;
					kraj = g;
				}
			}
		}

		System.out.println("Maksimum je " + max + " u intervalu od " + pocetak
				+ " do " + kraj);
		System.out.println("Broj racunskih operacija: " + brojOp);
	}

	static void maxNiza4(int[] niz) {
		int brojOp = 0;
		int max = 0;
		int pocetak = 1, kraj = 1;

		int n = niz.length;

		int maxDovde = 0;

		int d = 0;
		for (int i = 0; i < n; i++) {
			if (maxDovde == 0) {
				d = i;
			}
			maxDovde = maxDovde + niz[i];
			brojOp++;
			if (maxDovde < 0) {
				maxDovde = 0;
			}

			if (maxDovde > max) {
				max = maxDovde;
				pocetak = d;
				kraj = i;
			}
		}

		System.out.println("Maksimum je " + max + " u intervalu od " + pocetak
				+ " do " + kraj);
		System.out.println("Broj racunskih operacija: " + brojOp);
	}

	static void stampajNiz(int[] niz) {
		System.out.println("Duzina niza: " + niz.length);
		for (int i = 0; i < niz.length; i++) {
			System.out.println(i + " " + niz[i]);
		}
	}
	
	static int[] ucitajNiz() {
		Scanner in = new Scanner(System.in);
		System.out.print("Unesite broj brojeva u nizu X:");
		int n = in.nextInt();
		int[] niz = new int[n];

		System.out.print("Unesite niz x:");
		for (int i = 0; i < n; i++) {
			niz[i] = in.nextInt();
		}
		in.close();
		
		return niz;
	}

	public static void main(String[] args) {
		int[] niz = ucitajNiz();
				
		stampajNiz(niz);
		System.out.println();

		System.out.println("Metod 1: ");
		maxNiza1(niz);
		System.out.println();

		System.out.println("Metod 2: ");
		maxNiza2(niz);
		System.out.println();

		System.out.println("Metod 3: ");
		maxNiza3(niz);
		System.out.println();

		System.out.println("Metod 4: ");
		maxNiza4(niz);
	}
}