/**
 * Dat je fajl “sampioni-po-godinama.txt” u kome su u svakom redu godina i ime i
 * prezime šampiona Formule 1 te godine razdvojeni razmacima.
 * 
 * Ispisati na ekran koliko je bilo različitih šampiona (neki su bili u više
 * godina).
 * 
 * U novi fajl “sampioni.txt” ispisati jedinstvena imena, pri čemu redosled nije
 * bitan.
 * 
 * Dat je fajl “pobednici.txt” u kome je u svakom redu ime i prezime i broj
 * pobeda nekog vozača u Formuli 1. Koristeći ovaj i prethodno dat fajl ispisati
 * na ekran sve vozače koji su pobedili neku trku, ali nisu bili svetski
 * šampioni. Ispisati ove podatke u novi fajl “pobednici-bez-sampionata.txt”.
 *
 */
public class F1Vozaci {

	public static Skup<String> ucitajSampione(String imefajla) {
		Skup<String> rez = new Skup<>();

		while (!Svetovid.in(imefajla).isEmpty()) {
			// ignorisemo godinu, posto nam nije bitna (ne cuvamo je, ali je
			// moramo procitati)
			Svetovid.in(imefajla).readInt();
			String ime = Svetovid.in(imefajla).readString();
			String prezime = Svetovid.in(imefajla).readString();
			
			// u skup ubacujemo puno ime i prezime
			rez.ubaci(ime + " " + prezime);
		}
		Svetovid.in(imefajla).close();
		
		return rez;
	}

	public static Skup<String> ucitajPobednike(String imefajla) {
		Skup<String> rez = new Skup<>();

		while (!Svetovid.in(imefajla).isEmpty()) {
			String ime = Svetovid.in(imefajla).readString();
			String prezime = Svetovid.in(imefajla).readString();
			// ignorisemo podataka o broju pobeda (ne cuvamo ga, ali ga moramo
			// procitati)
			Svetovid.in(imefajla).readInt();
			rez.ubaci(ime + " " + prezime);
		}
		Svetovid.in(imefajla).close();
		
		return rez;
	}

	public static void stampajNiz(String[] niz) {
		if (niz != null)
			for (String s : niz)
				System.out.println(s);
	}

	public static void ispisiUFajl(Skup<String> imena, String imefajla) {
		// proveravamo da li je velicina veca od nula, jer inace napraviNiz
		// vraca 'null', sto ne mozemo da obradimo u foru
		if (imena.velicina() > 0) {
			String[] niz = imena.napraviNiz();
			for (String s : niz) {
				Svetovid.out(imefajla).println(s);
			}
			Svetovid.out(imefajla).close();
		} else {
			// nema sta da se pise u fajl
			Svetovid.out(imefajla).println();
			Svetovid.out(imefajla).close();
		}

	}

	public static void main(String[] args) {
		Skup<String> samp = (ucitajSampione("sampioni-po-godinama.txt"));
		// u skupu su sada samo razliciti sampioni, sto je trazeno
		System.out.println("Broj razlicitih sampiona:" + samp.velicina());
		ispisiUFajl(samp, "sampioni.txt");

		Skup<String> pob = ucitajPobednike("pobednici.txt");

		Skup<String> pBezS = pob.razlika(samp);

		// ispis na ekran
		System.out.println("Pobednici bez sampionata, ukupno " + pBezS.velicina());
		stampajNiz(pBezS.napraviNiz());

		ispisiUFajl(pBezS, "pobednici-bez-sampionata.txt");

	}

}
